var lastline="";
var uid = GuidNew();
// var shopId; // index.htmlの中で定義すること!
// var panoId; // index.htmlの中で定義すること!
// var loggerEnabled; // index.htmlの中で定義すること!
var panoLoadTime;
var lastViewAtTime; // for 実験ログ
var lastViewAtPosX; // for 実験ログ
var lastViewAtPosY; // for 実験ログ
var loggerDebugMode = false; // デバッグモード

// イベントIdの変換テーブル
var eventIdTbl = {'loadShop' : '0' , 'loadPano' : '1', 'unloadPano' : '2',
                    'clickItemSpot' : '3', 'clickItemDetail' : '4', 'clickItemTweet' : '5',
                    'clickPanoSpot' : '6', 'clickFloorLink' : '7',
                    'zoomAt' : '8', 'viewAt' : '9'};

$("body").ready(function(){
    AddLog("loadShop");
    AddLog("loadPano");
    
    $(window).unload(function(){
        AddLog("unloadPano");
    });
});

function AddLog(actionName, targetId, paramId)
{   
    var log = "";
    var eventId = eventIdTbl[actionName];
    var duration = "";
    var param = "";
    
    if (loggerEnabled == null || loggerEnabled == false) {
        return;
    }
    
    if (eventId == eventIdTbl['loadShop'])
    {
        param = navigator.userAgent;
        param += " ";
        param += $("body").width();
        param += "x";
        param += $("body").height();
        
        panoLoadTime = new Date();
    }
    else if (eventId == eventIdTbl['loadPano'])
    {
        if (targetId != void 0) { // targetIdが引数としてあるときはその値をpanoIdとする
            panoId = targetId;           
        }
        panoLoadTime = new Date();
    }
    else if (eventId == eventIdTbl['unloadPano'])
    {
        var now = new Date();
        duration = (now.getTime() - panoLoadTime.getTime()) / 1000; // ミリ秒→秒
    }
    else {
        if (paramId != void 0) {
            param = paramId;
        }
    }
        
    log = "&uid="+encodeURIComponent(uid)
        + "&shopId="+encodeURIComponent(shopId)
        + "&eventId=" + encodeURIComponent(eventId);

    if (panoId != void 0) { // void 0 はundefinedを返す
        log += "&panoId=" + encodeURIComponent(panoId)
    }

    if (targetId != void 0) { // void 0 はundefinedを返す
        log += "&targetId=" + encodeURIComponent(targetId);
    }

    if (duration != "") {
        log += "&duration=" + encodeURIComponent(duration);
    }

    if (param != "")
    {
       log += "&param=" + encodeURIComponent(param);
    }

    if (lastline != log)
    {
        var url = "url('http://cloud.panoplaza.com/ImageLog.aspx?"+log+"')";
        
        if (loggerDebugMode == true) {
            console.log(url);
        } else {
            $("body").css("background", url);            
        }
    }

    lastline = log;
}

function AddLogX(actionName, hlookat, vlookat, hfov, vfov)
{
    var log = "";
    var x = "";
    var y = "";
    var duration = "";
    var param = "";

    if (loggerEnabled == null || loggerEnabled == false) {
        return;
    }
    
    var eventId = eventIdTbl[actionName];

    if (eventId == eventIdTbl['zoomAt'])
    {
        x = hlookat;
        y = vlookat;
        param = hfov + "," + vfov;
    }
    else if (eventId == eventIdTbl['viewAt'])
    {
        var now = new Date();

        if (lastViewAtTime == void 0) {
            lastViewAtTime = now;
            lastViewAtPosX = hlookat;
            lastViewAtPosY = vlookat;
            return;
        }

        duration = (now.getTime() - lastViewAtTime.getTime()) / 1000; // ミリ秒→秒
        lastViewAtTime = now;

        if (lastViewAtPosX != void 0 && lastViewAtPosY != void 0) {
            x = lastViewAtPosX;
            y = lastViewAtPosY;
        }

        lastViewAtPosX = hlookat;
        lastViewAtPosY = vlookat;

        if (duration < 5) { // 有意でない場合（とりあえず5秒以上を閾値とする）はログに残さない
            return;
        }
    }

    log = "&uid="+encodeURIComponent(uid)
        + "&shopId="+encodeURIComponent(shopId)
        + "&eventId=" + encodeURIComponent(eventId);

    if (panoId != void 0) { // void 0 はundefinedを返す
        log += "&panoId=" + encodeURIComponent(panoId)
    }

    if (x != "")
    {
       log += "&x=" + encodeURIComponent(x);
    }

    if (y != "")
    {
       log += "&y=" + encodeURIComponent(y);
    }

    if (duration != "")
    {
       log += "&duration=" + encodeURIComponent(duration);
    }

    if (param != "")
    {
       log += "&param=" + encodeURIComponent(param);
    }

    if (lastline != log)
    {
        var url = "url('http://cloud.panoplaza.com/ImageLog.aspx?"+log+"')";
        
        if (loggerDebugMode == true) {
            console.log(url);
        } else {
            $("body").css("background", url);            
        }
    }

    lastline = log;
}

function GuidNew(){
    var S4 = function() {
       return (((1+Math.random())*0x10000)|0).toString(16).substring(1);
    };
    return (S4()+S4()+"-"+S4()+"-"+S4()+"-"+S4()+"-"+S4()+S4()+S4());
}

